#!/usr/bin/tclsh

global env
global gv
# einzige Aenderung die noetig sein sollte, ist den user, unter dessen rechten
# der anrufbeatworter bzw. dieses CGI laeuft, zu aendern: 
set gv(user) mail
set gv(debug) 0
set gv(newmsg_path) "/var/spool/vbox/$gv(user)/new"
set gv(archive_path) "/var/spool/vbox/$gv(user)/archive"
set gv(baseurl) "http://intranet.BfK-HD.de"
set gv(urlpath) "/~$gv(user)/cgi-bin/mbvbox.tcl"
set gv(trash)	"$gv(archive_path)/Papierkorb"

proc dummy {arg} {
    puts "Content-type: text/plain\n\n"
    puts "call to dummy with arg: $arg\n"
}

proc playwav {file} {
    global env
    global gv
    set mypid [pid]
    set tmpfile "/tmp/$mypid.wav"
    set ret [exec sox -t ul $file -t .wav - > $tmpfile]
    set no_bytes [file size $tmpfile]
    puts "Content-type: audio/x-wav"
    puts "Content-Description: test.wav (Audio-Clip (WAVE))"
    puts "Content-length: $no_bytes"
    puts ""
    exec >@ stdout sh -c "cat $tmpfile"
    file delete $tmpfile
}

proc playau {file} {
    global env
    global gv
    set mypid [pid]
    set tmpfile "/tmp/$mypid.AU"
    set ret [exec sox -t ul $file -t .au - > $tmpfile]
    set no_bytes [file size $tmpfile]
    puts "Content-type: audio/basic"
    puts "Content-Description: test.au (Audio-Clip (Basic))"
    puts "Content-length: $no_bytes"
    puts ""
    exec >@ stdout sh -c "cat $tmpfile"
    file delete $tmpfile
}

proc playhandler {action} {
    global env
    global gv

    set file [string range $action 12 end]
    if {$gv(audioformat) == "WAV"} then {
        playwav "$gv(folderpath)/$file"
    } else {
	playau "$gv(folderpath)/$file"
    }
    set dotpos [string last "." $file]
    set dotpos [expr $dotpos - 1]
    set infofile [string range $file 0 $dotpos] 
    exec /usr/bin/touch -m -t 010100001970.00 $gv(folderpath)/$infofile.vbox
}

proc main {} {
    global env
    global gv
    puts "Content-type: text/html\n\n"
    #-----------------------------------------------------------------------------
    puts {<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
}
    puts {<html>
}
    puts {<head>
}
    puts {   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
}
    if {$gv(aktualisierung) == 1 && $gv(aktualisierungsintervall) > 0 && $gv(aktualisierungsintervall) < 240 } then {
	set refreshtime [expr $gv(aktualisierungsintervall) * 60]
	puts "<meta http-equiv=\"refresh\" content=\"$refreshtime; URL=$gv(baseurl)$gv(urlpath)?$env(QUERY_STRING)\">"
    }
    puts {   <meta name="Author" content="Manuel Bessler (m.bessler@gmx.net)">
}
    puts {   <title>MBvbox</title>
}
    puts {</head>
}
    puts {<body text="#000000" bgcolor="#FFFFFF" link="#0000EE" vlink="#551A8B" alink="#FF0000">
}
    if {$gv(debug) == 1 } then {
        puts "$gv(paramlist)<br>$gv(action)"
    }
    puts {<form ACTION="mbvbox.tcl" METHOD="GET">
}
    puts "<input type=hidden name=\"aktualisierung\" value=\"$gv(aktualisierung)\">"
    puts {<table COLS=2 WIDTH="100%" >
}
    puts {<tr>
}
    puts {<td VALIGN=TOP WIDTH="25%" BGCOLOR="#E2E804">
}
    puts {<h4>
}
    puts {Audio-Format:</h4>
}
    if {$gv(audioformat) == "WAV"} then {
        puts "<input TYPE=\"RADIO\" NAME=\"audioformat\" VALUE=\"WAV\" CHECKED>WAV (Standard)
"
	puts "<br><input TYPE=\"RADIO\" NAME=\"audioformat\" VALUE=\"AU\" >AU
"
    } else {
        puts "<input TYPE=\"RADIO\" NAME=\"audioformat\" VALUE=\"WAV\" >WAV (Standard)
"
	puts "<br><input TYPE=\"RADIO\" NAME=\"audioformat\" VALUE=\"AU\" CHECKED>AU
"    
    }
    puts {<br>&nbsp;
}
    puts {<br>&nbsp;
}
    puts {<h4>
}
    puts {Automatisch aktualisieren:</h4>
}
    puts "alle&nbsp;<input name=\"aktualisierungsintervall\" value=\"$gv(aktualisierungsintervall)\" size=2 maxlength=2> Minuten"
    puts {<br><input type=submit name="action" value="Start">}
    puts {<br><input type=submit name="action" value="Stop">
}
    puts {<br>&nbsp;
}
    puts {<br>&nbsp;
}
    puts {<p><a href="ansageaendern.tcl">Konfiguration</a>
}
    puts {<br>&nbsp;
}
    puts {<br>&nbsp;
}
    puts "<p><a href=\"$gv(baseurl)\">"
    puts "Zur&uuml;ck zur<br>Intranet
 Hauptseite"
    puts {</a></td>
}
    puts {
}
    puts {<td WIDTH="75%" BGCOLOR="#33CCFF">
}
    puts {<h3>
Ordner: Neue Anrufe</h3>
}
    puts {<input TYPE="SUBMIT" NAME="action" VALUE="Ordner wechseln">}
    puts {<select name="Folderindex">}

    set i 0
    set foldername "Neue Anrufe"
    if {$gv(folderindex) == 0} then {
        puts "<option VALUE=\"$i\" SELECTED>$foldername</option>"
    } else {
        puts "<option VALUE=\"$i\">$foldername</option>"
    }
    incr i
    
    set folders [exec /bin/ls $gv(archive_path)]
    foreach dir $folders {
        set foldername "$dir"
	if {$gv(folderindex) == $i} then {
	    puts "<option VALUE=\"$i\" SELECTED>$foldername</option>"
	} else {
	    puts "<option VALUE=\"$i\">$foldername</option>"
	}
	incr i
    }

    puts {</select>
}
    puts {<br>&nbsp;
}
    puts {<br>&nbsp;
}
    puts {<br>
}
    puts {<center>
}
    puts {<p><h1>Anrufliste:</h1></center>
}
    puts {
}
    puts {<p><input TYPE="SUBMIT" NAME="action" VALUE="Liste aktualisieren">
}
    puts {<table BORDER="0" cellpadding="0" cellspacing="0" WIDTH="100%" >
}
    puts {<tr BGCOLOR="#666699">
}
    puts {<td><center>Mark</center></td>
}
    puts {
}
    puts {<td>
}
    puts {<center>Neu</center>
}
    puts {</td>
}
    puts {
}
    puts {<td>
}
    puts {<center>Datum Zeit</center>
}
    puts {</td>
}
    puts {
}
    puts {<td>
}
    puts {<center>Nummer</center>
}
    puts {</td>
}
    puts {
}
    puts {<td>
}
    puts {<center>Name</center>
}
    puts {</td>
}
    puts {
}
    puts {<td>
}
    puts {<center>Dauer</center>
}
    puts {</td>
}
    puts {</tr>
}
    #-------------------

    #-------------------

    set folders [exec /bin/ls $gv(archive_path)]
    if {$gv(folderindex) == 0} then {
	set allfiles [exec /bin/ls -r $gv(newmsg_path)]
    } else {
        set allfiles [exec /bin/ls -r $gv(archive_path)/[lindex $folders [expr $gv(folderindex) - 1]]]
    }


    set msgfile_list ""
    set infofile_list ""
    foreach file $allfiles {
	set len [string length $file]
        set dotpos [expr $len - 5]
	if {[string range $file $dotpos end] == ".ulaw"} then {
    	    lappend msgfile_list $file
        }
	if {[string range $file $dotpos end] == ".vbox"} then {
		lappend infofile_list $file
        }
    }
    set i 0

    foreach msgfile $msgfile_list {
	set infofd [open [file join $gv(folderpath) [lindex $infofile_list $i]] r]
        gets $infofd callname
	gets $infofd callid
        gets $infofd calltime
	set calltime [string range $calltime 6 end]
        set callid [string range $callid 6 end]
	set callname [string range $callname 6 end]

	set filesize [file size [file join $gv(folderpath) $msgfile]]
	set duration [expr round([expr $filesize / 8060.0])]

        puts {
}
	if {[expr $i % 2] == 0} then {
		puts {<tr bgcolor="#DDDDDD">
}
	} else {
		puts {<tr bgcolor="#EEEEEE">
}	
	}
	set msgid [string trim $msgfile ".ulaw"]
	set markidx [lsearch -regexp $gv(paramlist) "mark$msgid.*"]

        if {$markidx != -1 && $gv(unmarkall) != 1 && $gv(action) != "action=Als+neu+markieren" && $gv(action) != "action=Neu-Markierung+entfernen"} then {
            puts "<td><input TYPE=\"CHECKBOX\" NAME=\"mark$msgid\" CHECKED></td>"
	} elseif {$gv(markall) == 1 && $gv(unmarkall) != 1 && $gv(action) != "action=Als+neu+markieren" && $gv(action) != "action=Neu-Markierung+entfernen"} {
            puts "<td><input TYPE=\"CHECKBOX\" NAME=\"mark$msgid\" CHECKED></td>"	
	} else {
            puts "<td><input TYPE=\"CHECKBOX\" NAME=\"mark$msgid\"></td>"	
	}
        puts {
}
	
	set msgfile_mtime [file mtime [file join $gv(folderpath) $msgfile]]
	set infofile_mtime [file mtime [file join $gv(folderpath) [lindex $infofile_list $i]]]
	# msg is marked new if mtime > 3600
	# it means that the infofile (.vbox) of the corresponding msg that has been 
	# requested to play will be touched so it has a mtime of (about) epoch (1.1.1970 midnight)
	if {$infofile_mtime < 3600 } then {
	    set isnew 0
        } else {
    	    set isnew 1
        }

	if {$gv(action) == "action=Als+neu+markieren"} then {
    	    if {$markidx != -1} then {
		puts "<td><center><img SRC=\"/icons/haken.gif\" alt=\"ja\"></center></td>"
		set newmtime [clock format $msgfile_mtime -format "%m%d%H%M%Y.%S"]
    		exec /usr/bin/touch -m -t $newmtime [file join $gv(folderpath) [lindex $infofile_list $i]]
	    } elseif {$isnew} {
		puts "<td><center><img SRC=\"/icons/haken.gif\" alt=\"ja\"></center></td>"
	    } else {
		puts "<td>&nbsp;</td>
"
	    }
	} elseif {$gv(action) == "action=Neu-Markierung+entfernen"} then {
    	    if {$markidx != -1} then {
		puts "<td>&nbsp;</td>
"
		exec /usr/bin/touch -m -t 010100001970.00 [file join $gv(folderpath) [lindex $infofile_list $i]]
	    } elseif {$isnew} {
		puts "<td><center><img SRC=\"/icons/haken.gif\" alt=\"ja\"></center></td>"
	    } else {
		puts "<td>&nbsp;</td>
"
	    }	
	} else {
            if {$isnew} then {
		puts "<td><center><img SRC=\"/icons/haken.gif\" alt=\"ja\"></center></td>"
    	    } else {
		puts "<td>&nbsp;</td>
"
    	    }
	}
        puts {
}

        set calldatetime [clock format $calltime]
        puts "<td>$calldatetime</td>
"
        puts {
}
        puts "<td>$callid</td>
"
        puts {
}

        puts "<td><a href=\"$gv(baseurl)$gv(urlpath)?action=play-$msgfile\">abspielen</a></td>"

        puts {
}
        puts "<td><p align=right>$duration</p></td>
"
        puts {</tr>
}
        close $infofd
        incr i
    }
    #--------------------

    #--------------------
    puts {
}
    puts {</table>}
    puts {<input TYPE="SUBMIT" NAME="action" VALUE="Alle Markieren">
<input TYPE="SUBMIT" NAME="action" VALUE="Keine Markieren"><br><br>}
    puts {Markierte Anrufe&nbsp;&nbsp;}
    if {$gv(folderpath) == $gv(trash)} then {
        puts {<input TYPE="SUBMIT" NAME="action" VALUE="Papierkorb leeren">&nbsp;&nbsp;}
    }
    puts {<input TYPE="SUBMIT" NAME="action" VALUE="Als neu markieren">
&nbsp;}
    puts {<input TYPE="SUBMIT" NAME="action" VALUE="Neu-Markierung entfernen">
&nbsp;}
    puts "<br>"
    puts {<input TYPE="SUBMIT" NAME="action" VALUE="Verschieben">
nach:&nbsp;}

    puts "<select name=\"movefolder\">"

    set i 0
    set mvfoldername "Neue Anrufe"
    if {$gv(mvfolderindex) == 0} then {
        puts "<option VALUE=\"$i\" SELECTED>$mvfoldername</option>"
    } else {
        puts "<option VALUE=\"$i\">$mvfoldername</option>"
    }
    incr i
    
    set mvfolders [exec /bin/ls $gv(archive_path)]
    foreach dir $mvfolders {
        set mvfoldername "$dir"
	if {$gv(mvfolderindex) == $i} then {
	    puts "<option VALUE=\"$i\" SELECTED>$mvfoldername</option>"
	} else {
	    puts "<option VALUE=\"$i\">$mvfoldername</option>"
	}
	incr i
    }
    
    puts {</select>
}

    puts {<p><input TYPE="SUBMIT" NAME="action" VALUE="Liste aktualisieren">}
    puts {<br>&nbsp;
}
    puts {<br>&nbsp;
}
    puts {<br>&nbsp;
}
    puts {<br>&nbsp;
}
    puts {<p>&nbsp;</td>
}
    puts {</tr>
}
    puts {</table>}
    puts {</form>
}
    puts "<img src=\"/icons/powered_by_linux.gif\" align=ABSCENTER><img src=\"/icons/gfx_by_gimp.gif\" align=ABSCENTER>"
    puts "<h6> MBVBox.tcl (c) Copyright 1999 by Manuel Bessler </h6>"
    puts {</body>
}
    puts {</html>
}
    #----------------------------------------------------------------------------
}

proc movemsgs {} {
    global gv
    
    set i 0
    set mvfolders [exec /bin/ls $gv(archive_path)]
    if {$gv(mvfolderindex) == 0} then {
        set mvfoldername "Neue Anrufe"	
    } else {
        foreach dir $mvfolders {
	    incr i
	    if {$gv(mvfolderindex) == $i} then {
		set mvfoldername "$dir"
	    }
        }
    }

    puts "Content-type: text/html\n\n"
    puts {<html>
}
    puts {<head>
}
    puts {   <title>MBvbox</title>
}
    puts {</head>
}
    puts {<body text="#FFFFFF" bgcolor="#FF0000" link="#0000EE" vlink="#551A8B" alink="#FF0000">
}
    if {$gv(debug) == 1 } then {
        puts "$gv(paramlist)"
    }
    if {$gv(mvfolderindex) == $gv(folderindex) } then {
	puts {<br>}
	puts "Die markierten Nachrichten befinden sich schon in Ordner $mvfoldername"
        puts {</body>
}
	puts {</html>
}
	return
    }
    puts {<br>}

    set marklist ""
    foreach lelem $gv(paramlist) {
	if {[string match "mark*" $lelem]} then {
	    set lelem [string range $lelem 4 end]
	    set lelem [string range $lelem 0 [expr [string first "=" $lelem] - 1 ]]
	    lappend marklist $lelem
	}
    }
    

    puts "Nachrichten:<br>"
    foreach i $marklist {
    exec /bin/mv $gv(folderpath)/$i.ulaw $gv(mvfolderpath)/
    exec /bin/mv $gv(folderpath)/$i.vbox $gv(mvfolderpath)/
	puts "Nachricht $i<br>"
    }
    puts "wurden in Ordner $mvfoldername verschoben"
    puts "<br><br><br><br>"
    puts "<a href=\"$gv(baseurl)$gv(urlpath)\">weiter</a>"
    puts {</body>
}
    puts {</html>
}

}

proc empty_trash {} {
    global gv
    set trash_files [exec /bin/ls $gv(trash)]
    set rmfiles ""
    foreach file $trash_files {
	if {[string last ".vbox" $file] != -1} then {lappend rmfiles $file}
	if {[string last ".ulaw" $file] != -1} then {lappend rmfiles $file}
    }
    foreach file $rmfiles {
	exec /bin/rm $gv(trash)/$file
    }
}

proc init {} {
    global gv

    set i [lsearch -regexp $gv(paramlist) "audioformat=.*"]
    if {$i != -1 } then {
	set gv(audioformat) [lindex $gv(paramlist) $i]
        set gv(audioformat) [string range $gv(audioformat) 12 end]
    } else {set gv(audioformat) "WAV"}

    set actionindex [lsearch -regexp $gv(paramlist) "action=.*"]
    if {$actionindex != -1 } then {
	set gv(action) [lindex $gv(paramlist) $actionindex]
    } else {set gv(action) ""}


    set i [lsearch -regexp $gv(paramlist) "aktualisierungsintervall=.*"]
    if {$i != -1 } then {
        set gv(aktualisierungsintervall) [lindex $gv(paramlist) $i]
        set gv(aktualisierungsintervall) [string range $gv(aktualisierungsintervall) 25 end]
    } else {set gv(aktualisierungsintervall) ""}

    set i [lsearch -regexp $gv(paramlist) "aktualisierung=.*"]
    if {$i != -1 } then {
	set gv(aktualisierung) [lindex $gv(paramlist) $i]
        set gv(aktualisierung) [string range $gv(aktualisierung) 15 end]
    } else {set gv(aktualisierung) 0}

    if {$gv(aktualisierungsintervall) > 0 && $gv(aktualisierungsintervall) < 240 && $gv(action) == "action=Start"} then {
	set gv(aktualisierung) 1
    } elseif {$gv(aktualisierung) == 1 && $gv(action) != "action=Stop"} {
	set gv(aktualisierung) 1
      } else {set gv(aktualisierungsintervall) ""}


    set gv(folderindex) 0
    
    set i [lsearch -regexp $gv(paramlist) "Folderindex=.*"]
    if {$i != -1 } then {
        set gv(folderindex) [lindex $gv(paramlist) $i]
	set gv(folderindex) [string range $gv(folderindex) 12 end]
    } else {set gv(folderindex) 0}
    
    set folders [exec /bin/ls $gv(archive_path)]
    if {$gv(folderindex) == 0} then {
	set gv(folderpath) $gv(newmsg_path)
    } else {
	set folder [lindex $folders [expr $gv(folderindex) - 1 ]]
	set gv(folderpath) "$gv(archive_path)/$folder"
    }


    set gv(mvfolderindex) 0
    set i [lsearch -regexp $gv(paramlist) "movefolder=.*"]
    if {$i != -1 } then {
        set gv(mvfolderindex) [lindex $gv(paramlist) $i]
	set gv(mvfolderindex) [string range $gv(mvfolderindex) 11 end]
    } else {set gv(mvfolderindex) 0}

    set mvfolders [exec /bin/ls $gv(archive_path)]
    if {$gv(mvfolderindex) == 0} then {
	set gv(mvfolderpath) $gv(newmsg_path)
    } else {
	set mvfolder [lindex $mvfolders [expr $gv(mvfolderindex) - 1 ]]
	set gv(mvfolderpath) "$gv(archive_path)/$mvfolder"
    }

    set gv(markall) 0
    set gv(unmarkall) 0

}

global env
global gv
set gv(paramlist) ""
set gv(paramlist) [split $env(QUERY_STRING) "&"]
init


switch -regexp -- "$gv(action)" {
    ^action=play-[.]* 				{ playhandler $gv(action) }
    ^action=Start$ 				{ main }
    ^action=Stop$				{ set gv(aktualisierung) 0
						  set gv(aktualisierungsintervall) ""
    						  main 
						}
    ^action=Ordner[+]wechseln$			{ main }
    ^action=Liste[+]aktualisieren$ 		{ main }
    ^action=Alle[+]Markieren$			{ set gv(markall) 1 ; main }
    ^action=Keine[+]Markieren$			{ set gv(unmarkall) 1 ; main }
    ^action=Papierkorb[+]leeren$ 		{ empty_trash ; main }
    ^action=Verschieben$			{ movemsgs }
    ^action=Als[+]neu[+]markieren$ 		{ main }
    ^action=Neu-Markierung[+]entfernen$		{ main }
    ""						{ main }
    default 					{ main }
}


